﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FoodController : MonoBehaviour
{
    public float xRange;
    public float yRange;
    private bool isMoving = false;
    private bool exhausted;
    public float speed;
    public float staminaTime;
    public float regenerateStaminaTime;
    private float staminaTimer = 10;
    public int[] position;
    // public IEffect[] effects;
    public IEatable eatable;
    private Vector2 currentWaypoint;

    public GridLayout gridLayout;
    AnimationCurve bobSide;
    AnimationCurve bobFront;
    Quaternion targetRotation;
    private float lookTimer;
    private float lookTime = 0.2f;

    public float movementTimer;
    private float movementTime;
    private Vector2 startPos;



    // effect system for peeps
    // Start is called before the first frame update
    void Start()
    {
        // effects = GetComponents<IEffect>();
        eatable = GetComponent<IEatable>();
        CheckGridPos();
    }

    // Update is called once per frame
    void Update()
    {
        if (isMoving)
        {

            lookTimer += Time.deltaTime;
            if (lookTimer < lookTime)
            {
                transform.rotation = Quaternion.Lerp(transform.rotation, targetRotation, lookTime / lookTimer);
            }
            staminaTimer += Time.deltaTime;
            if (staminaTimer > staminaTime)
            {
                staminaTimer = 0;
                staminaTime = Random.Range(2.2f, 6.1f);
                isMoving = false;
            }
            movementTimer += Time.deltaTime;
            Vector2 newPos = Vector2.Lerp(startPos, currentWaypoint, movementTimer / movementTime);
            transform.position = new Vector3(newPos.x, transform.position.y, newPos.y);
            // Mathf.PingPong
            //Vector2 dir = (currentWaypoint - new Vector2(transform.position.x, transform.position.z)).normalized;
            // if (dir.x > 0)
            // {
            //     if (dirSign==false)
            //     {
            //         staminaTimer = 0;
            //         staminaTime = Random.Range(2.2f, 6.1f);
            //         isMoving = false;
            //     }
            // }
            //  if (dir.x < 0)
            // {
            //     if (dirSign)
            //     {
            //         staminaTimer = 0;
            //         staminaTime = Random.Range(2.2f, 6.1f);
            //         isMoving = false;
            //     }
            // }
            // if ((new Vector2(transform.position.x, transform.position.z) - startPos).sqrMagnitude > (currentWaypoint - startPos).sqrMagnitude)
            // {
            //     staminaTimer = 0;
            //     staminaTime = Random.Range(2.2f, 6.1f);
            //     isMoving = false;
            // }
            // if (transform.position.x + dir.x * speed > xRange || transform.position.x + dir.x * speed < -xRange || transform.position.y + dir.y * speed > yRange || transform.position.y + dir.y * speed < -yRange)

            // {
            //     staminaTimer = 0;
            //     staminaTime = Random.Range(2.2f, 6.1f);
            //     isMoving = false;
            // }
            // transform.Translate(new Vector3(dir.x, 0, dir.y) * speed);

            CheckGridPos();
            //move

        }
        else
        {

            //transform.rotation = Quaternion.EulerAngles()
            staminaTimer += Time.deltaTime;
            if (regenerateStaminaTime < staminaTimer)
            {
                regenerateStaminaTime = Random.Range(0, 0.7f);
                FindNewTarget();
                isMoving = true;
            }
        }
    }
    void CheckGridPos()
    {
        int x;
        int y;
        gridLayout.GetCellIndexesFromWorldPos(new Vector2(transform.position.x, transform.position.z), out x, out y);
        position = new int[2] { x, y };
    }

    void FindNewTarget()
    {
        currentWaypoint = new Vector2(Random.Range(-xRange, xRange), Random.Range(-yRange, yRange));
        targetRotation = Quaternion.LookRotation((new Vector3(currentWaypoint.x, transform.position.y, currentWaypoint.y) - transform.position), Vector3.up);
        lookTimer = 0;
        startPos = new Vector2(transform.position.x, transform.position.z);
        movementTime = (currentWaypoint - startPos).sqrMagnitude / speed;
        movementTimer = 0;
        // if ((currentWaypoint - new Vector2(transform.position.x, transform.position.z)).x > 0)
        // {
        //     dirSign = true;
        // }

    }

    void GenerateWaypoints()
    {

    }


}
