﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

public class CanvasScript : MonoBehaviour
{
    public GameObject[] gameObjects;
    public Button ButtonSP;
    public Button ButtonNP;
    public Button ButtonMEP;

    float cooldown;
    float CurrentTime;
    int iterator = 0;
    void Start()
    {
        cooldown = 300;
        CurrentTime = Time.time * 500;

        foreach(GameObject gameObject in gameObjects)
        {
            gameObject.SetActive(false);
        }
        gameObjects[0].SetActive(true);

        ButtonSP.onClick.AddListener(delegate
        {
            OnButtonSPClick(ButtonSP);
        });

        ButtonNP.onClick.AddListener(delegate
        {
            OnButtonNPClick(ButtonSP);
        });

        ButtonMEP.onClick.AddListener(delegate
        {
            OnButtonMEPClick(ButtonSP);
        });


    }
    
    public void OnButtonSPClick(Button button)
    {
        int i = 2;
        SceneManager.LoadScene(i);
    }

    public void OnButtonNPClick(Button button)
    {
        int i = 1;
        SceneManager.LoadScene(i);
    }

    public void OnButtonMEPClick(Button button)
    {
        int i = 3;
        SceneManager.LoadScene(i);
    }


    void Update()
    {
        if(Input.anyKeyDown && (Time.time * 1000 - CurrentTime > cooldown))
        {
            CurrentTime = Time.time * 1000;
            if(iterator < gameObjects.Length - 1)
            {
                gameObjects[iterator++].SetActive(false);
                gameObjects[iterator].SetActive(true);
            }
        }
    }
}
