﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class FoodManager : MonoBehaviour
{
    public float yOffset;
    public List<FoodController> food;
    public GameObject[] foodTypes;
    public float chanceForSpecial;
    public int foodAmount;
    public GridLayout gridLayout;
    public int avgRatePerSec = -1; // = 5 
    // Start is called before the first frame update
    void Start()
    {

    }

    // Update is called once per frame
    private void Update()
    {
        if (food.Count < foodAmount)
        {

            int rand = Random.Range(avgRatePerSec - 2, avgRatePerSec + 3);
            for (int i = 0; i < rand; i++)
            {

                int k = 0;
                if (Random.value < chanceForSpecial)
                {
                    k = Random.Range(1, foodTypes.Length - 2);
                    if (Random.value > 0.9f)
                        k = foodTypes.Length - 1;
                }
                Vector2 outV;
                gridLayout.GetWorldPosFromCellIndexes(0, 0, out outV);
                Vector2 outV2;
                gridLayout.GetWorldPosFromCellIndexes(gridLayout.Width - 1, gridLayout.Height - 1, out outV2);
                Vector3 spawnPoint = new Vector3(Random.Range(outV.x, outV2.x), yOffset, Random.Range(outV.y, outV2.y));

                FoodController foodCntrl = GameObject.Instantiate(foodTypes[k], spawnPoint, Quaternion.identity, this.transform).GetComponent<FoodController>();
                foodCntrl.xRange = outV2.x;
                foodCntrl.yRange = outV2.y;
                foodCntrl.gridLayout = gridLayout;
                food.Add(foodCntrl);
            }
        }
    }
    public List<FoodController> CheckFood(int[] pos)
    {




        List<FoodController> toEat = new List<FoodController>();
        foreach (var piece in food)
        {
            if (piece.position.Length > 1)
            {
                if (piece.position[0] == pos[0] && piece.position[1] == pos[1])
                {
                    toEat.Add(piece);
                }
            }
        }


        return toEat;
    }
}
